// UTF-8 ÄÖÜ 馬
#region using System;
using System;
using System.Collections.Generic;
using System.IO;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using ns_tools;
using ns_wpf_ex;
using ns_wpf_dlg;
using static ns_tools.ts_tools;
using static ns_tools.ts_ui_tools;
using static ns_wpf_ex.ts_wpf_tools;
using ns_wt20_dll;
#endregion
namespace ns_wt20_test {
  /// <summary>
  /// Interaction logic for MainWindow.xaml
  /// </summary>
  public partial class MainWindow: WindowEx {
    #region var
    private const string cn_input = "input";
    private const string cn_geo = "geo";
    private const string cn_betrp = "betrp";
    private const string cn_rechnung = "rechnung";

    const int ausl_Auslegung = 0;
    const int ausl_Nachrechnung = 1;
    const int ausl_Reserve = 2;

    public List<Dictionary<string, object>> l_med;
    public List<Dictionary<string, object>> l_ansch_typ;
    public List<Dictionary<string, object>> l_ansch;
    public List<Dictionary<string, object>> l_lam;
    public List<Dictionary<string, object>> l_mat;
    public List<Dictionary<string, object>> l_kernrohr;
    public List<Dictionary<string, object>> l_sam;

    public static to_geo geo = new to_geo();
    public static to_betrp betrp = new to_betrp();
    public static to_wt_data_bound wt_data_bound = new to_wt_data_bound(geo, betrp);
    #endregion 0000000A01

    #region public MainWindow()
    public MainWindow() {
      dimensions.init_dim();

      var args = Environment.GetCommandLineArgs();
      var arg0 = args[0];
      var start_dir = Path.GetDirectoryName(arg0);
      ns_wt20_dll.to_wt20_dll.init(start_dir);

      InitializeComponent();
      this.LocationPersistent = true;
      this.grd_geo_out.IsEnabled = false;
      this.grd_betrp_out.IsEnabled = false;
      this.grd_geo_out.Visibility = Visibility.Collapsed;
      this.grd_betrp_out.Visibility = Visibility.Collapsed;
      this.grd_geo_in.Background = Brushes.LightYellow;
      this.grd_betrp_in.Background = Brushes.LightYellow;
      this.grd_geo_out.Background = Brushes.LightGray;
      this.grd_betrp_out.Background = Brushes.LightGray;
      // nbk.add_page("Nachrechnung");

      if (true) {
        string s;
        Dictionary<string, object> d;

        #region s = (WindowEx.read_program_ini(null, cn_input) as string) ?? "";
        s = (WindowEx.read_program_ini(null, cn_input) as string) ?? "";
        edt_in.Text = s;
        #endregion
        #region s = (WindowEx.read_program_ini(null, cn_rechnung) as string) ?? "";
        s = (WindowEx.read_program_ini(null, cn_rechnung) as string) ?? "";
        if (Int32.TryParse(s, out int rechnung)) {
          set_radio(this, "rechnung", rechnung);
          }
        #endregion
        #region s = (WindowEx.read_program_ini(null, cn_geo) as string) ?? "";
        s = (WindowEx.read_program_ini(null, cn_geo) as string) ?? "";
        d = d_from_json(s);
        if (!(d is null)) {
          geo.extract_dict(d);
          }
        #endregion
        #region s = (WindowEx.read_program_ini(null, cn_betrp) as string) ?? "";
        s = (WindowEx.read_program_ini(null, cn_betrp) as string) ?? "";
        d = d_from_json(s);
        if (!(d is null)) {
          betrp.extract_dict(d);
          }
        #endregion
        }
      set_radio(this, "FLE", betrp.select_FLE);
      set_radio(this, "KA", betrp.select_KA);
      set_radio(this, "luftstrom", betrp.select_luftstrom);

      try {
        if (true) {
          string s;
          #region l_med
          s = ns_wt20_dll.to_wt20_dll.dispatcher("{\"mode\": \"query_med\"}");
          l_med = ld_from_json(s);
          #endregion 0000000201
          #region l_ansch_typ
          s = ns_wt20_dll.to_wt20_dll.dispatcher("{\"mode\": \"query_ansch_typ\"}");
          l_ansch_typ = ld_from_json(s);
          #endregion 0000000201
          #region l_ansch
          s = ns_wt20_dll.to_wt20_dll.dispatcher("{\"mode\": \"query_ansch\"}");
          l_ansch = ld_from_json(s);
          #endregion 0000000201
          #region l_lam
          s = ns_wt20_dll.to_wt20_dll.dispatcher("{\"mode\": \"query_lam\"}");
          l_lam = ld_from_json(s);
          #endregion 0000000201
          #region l_mat
          s = ns_wt20_dll.to_wt20_dll.dispatcher("{\"mode\": \"query_mat\"}");
          l_mat = ld_from_json(s);
          #endregion 0000000201
          #region l_kernrohr
          s = ns_wt20_dll.to_wt20_dll.dispatcher("{\"mode\": \"query_rohr\"}");
          l_kernrohr = ld_from_json(s);
          #endregion 0000000201
          #region l_sam
          s = ns_wt20_dll.to_wt20_dll.dispatcher("{\"mode\": \"query_sam\"}");
          l_sam = ld_from_json(s);
          #endregion 0030000201000206000201
          }

        #region cmb_rohr
        /*
          "key" : "BTN12.7",
          "rohr_key" : "BTN12.7",
          "name" : "BTN12.7",
          "mat_key" : "Cu",
          "adia_display mm" : 12
        */
        foreach (var q in l_kernrohr) {
          cmb_rohr_in.Items.Add(new ComboBoxItem { Content = q["name"], Tag = q });
          }
        #endregion 0000000903
        #region cmb_lamelle
        /*
          "key" : "9.5:25x22v1",
          "name" : "25x22 Lam1",
          "rohr_key" : "9.5",
          "raster_h mm" : 25,
          "raster_t mm" : 21.650635094611,
          "fluchtend" : false,
          "glattrohr" : false,
          "fin_form" : "genoppt",
          "fin_form_short" : "Lam1",
          "suffix" : "L1"
        */
        foreach (var q in l_lam) {
          cmb_lamelle_in.Items.Add(new ComboBoxItem { Content = q["name"], Tag = q });
          }
        #endregion 0000000E04
        #region cmb_sam_dia
        /*
          "key" : "12",
          "name" : "12",
          "mat_key" : "Cu",
          "diameter mm" : 12,
          "nenndurchmesser" : "DN 15",
          "thickness mm" : 0.7
        */
        foreach (var q in l_sam) {
          cmb_sam_dia_in.Items.Add(new ComboBoxItem { Content = q["name"] + ", " + q["nenndurchmesser"], Tag = q });
          cmb_sam_dia_out.Items.Add(new ComboBoxItem { Content = q["name"] + ", " + q["nenndurchmesser"], Tag = q });
          }
        #endregion 0000000A03
        #region cmb_med_typ
        foreach (var q in l_med) {
          cmb_med_typ_in.Items.Add(new ComboBoxItem { Content = q["name"], Tag = q });
          }
        #endregion 0000000204

        geo.ansch_typ = "LN";
        set_cmb_key(cmb_rohr_in, geo.rohr_key);
        set_cmb_key(cmb_sam_dia_in, geo.sammler_key);
        set_cmb_key(cmb_lamelle_in, geo.lam_key);
        set_cmb_key(cmb_med_typ_in, betrp.med_key);

        this.DataContext = new to_bindable_data<to_wt_data_bound>(wt_data_bound);
        rb_rechnung_Click(null, null);

        // edt_teile.ValueChanged += (s, e) => {
        //   set_grid_spacing(grid_0, edt_teile.Value.Value);
        // };
        }
      catch (Exception ex) {
        exception_box(ex);
        }
      }
    #endregion 000C001D07001D0C

    // Events
    #region private void btn_go_Click(object sender, RoutedEventArgs e)
    private void btn_go_Click(object sender, RoutedEventArgs e) {
      try {
        WindowEx.modify_program_ini(null, cn_input, edt_in.Text);
        edt_out.Text = ns_wt20_dll.to_wt20_dll.dispatcher(edt_in.Text);
        }
      catch (Exception ex) {
        edt_out.Text = ex.Message ?? "???";
        }
      }
    #endregion
    #region private void cmb_rohr_SelectionChanged(object sender, SelectionChangedEventArgs e)
    private void cmb_rohr_SelectionChanged(object sender, SelectionChangedEventArgs e) {
      var rohr = (cmb_rohr_in.SelectedItem as ComboBoxItem)?.Tag as Dictionary<string, object>;
      cmb_lamelle_in.Items.Clear();
      foreach (var q in l_lam) {
        if (q["rohr_key"] as string == rohr["rohr_key"] as string) {
          cmb_lamelle_in.Items.Add(new ComboBoxItem { Content = q["name"], Tag = q });
          }
        }
      }
    #endregion
    #region private void btn_calc_Click(object sender, RoutedEventArgs e)
    class to_ausl {
      public Dictionary<string, object> geo;
      public Dictionary<string, object> betrp_ausl;
      public Dictionary<string, object> betrp_sim;

      public string wt_typ_string => (geo?.GetValueOrNull("wt_typ_string") as string) ?? "??";
      }
    private void btn_calc_Click(object sender, RoutedEventArgs e) {
      try {
        var rechnung = get_radio(this, "rechnung");
        betrp.select_FLE = get_radio(this, "FLE");
        betrp.select_KA = get_radio(this, "KA");
        betrp.select_luftstrom = get_radio(this, "luftstrom");

        geo.rohr_key = ((cmb_rohr_in.SelectedItem as ComboBoxItem)?.Tag as Dictionary<string, object>)?.GetValue("key") as string ?? "";
        geo.sammler_key = ((cmb_sam_dia_in.SelectedItem as ComboBoxItem)?.Tag as Dictionary<string, object>)?.GetValue("key") as string ?? "";
        geo.lam_key = ((cmb_lamelle_in.SelectedItem as ComboBoxItem)?.Tag as Dictionary<string, object>)?.GetValue("key") as string ?? "";
        betrp.med_key = ((cmb_med_typ_in.SelectedItem as ComboBoxItem)?.Tag as Dictionary<string, object>)?.GetValue("key") as string ?? "";

        var d_geo = geo.as_dict();
        var d_betrp = betrp.as_dict();
        var j_geo = fastJSON.JSON.ToNiceJSON(d_geo);
        var j_betrp = fastJSON.JSON.ToNiceJSON(d_betrp);
        WindowEx.modify_program_ini(null, cn_rechnung, rechnung.ToString());
        WindowEx.modify_program_ini(null, cn_geo, j_geo);
        WindowEx.modify_program_ini(null, cn_betrp, j_betrp);
        var d_src = new Dictionary<string, object>();
        string mode = "";
        switch (rechnung) {
        case ausl_Auslegung:
          mode = "auslegung";
          break;
        case ausl_Nachrechnung:
          mode = "nachrechnung";
          break;
        case ausl_Reserve:
          mode = "reserve";
          break;
          }
        d_src.Add("mode", mode);
        d_src.Add("geo", d_geo);
        d_src.Add("l_betrp", new List<object> { d_betrp });
        var j_src = fastJSON.JSON.ToNiceJSON(d_src);
        edt_in.Text = j_src;
        var j_tgt = ns_wt20_dll.to_wt20_dll.dispatcher(j_src);
        edt_out.Text = j_tgt;

        wt_data_bound.geo_out = null;
        wt_data_bound.betrp_out = null;
        lbl_wt_typ.Text = "";

        if (j_tgt != null &&
            (j_tgt.StartsWith("{") ||
             j_tgt.StartsWith("["))) {
          var d_tgt = d_from_json(j_tgt);
          if (!(d_tgt is null)) {
            if (rechnung == ausl_Auslegung) {
              // Auslegung
              if (d_tgt.TryGetValue("l_auslegung", out var o_auslegung)) {
                if (o_auslegung is List<object> l_auslegung) {
                  var l_select = new List<to_ausl>();
                  foreach (var o_ausl in l_auslegung) {
                    if (o_ausl is Dictionary<string, object> d_ausl) {
                      var ausl = new to_ausl();
                      l_select.Add(ausl);
                      if (d_ausl.TryGetValue("geo", out var o_geo)) {
                        ausl.geo = o_geo as Dictionary<string, object>;
                        }
                      if (d_ausl.TryGetValue("betrp_ausl", out var o_betrp_ausl)) {
                        ausl.betrp_ausl = o_betrp_ausl as Dictionary<string, object>;
                        }
                      if (d_ausl.TryGetValue("betrp_sim", out var o_betrp_sim)) {
                        ausl.betrp_sim = o_betrp_sim as Dictionary<string, object>;
                        }
                      }
                    }
                  var frm_sel = new frm_select();
                  frm_sel.add_column("Typ", nameof(to_ausl.wt_typ_string));
                  if (frm_select.select<to_ausl>(frm_sel, l_select, out var sel_aus) == ModalResult.OK) {
                    var geo_out = new to_geo();
                    geo_out.extract_dict(sel_aus.geo);
                    set_cmb_key(cmb_sam_dia_out, geo_out.sammler_key);
                    wt_data_bound.geo_out = new to_bindable_data<to_geo>(geo_out);
                    var betrp_out = new to_betrp();
                    betrp_out.extract_dict(sel_aus.betrp_ausl);
                    wt_data_bound.betrp_out = new to_bindable_data<to_betrp>(betrp_out);
                    lbl_wt_typ.Text = sel_aus.wt_typ_string;
                    }
                  }
                }
              }
            else {
              // Nachrechnung/Reserve
              if (d_tgt.TryGetValue("geo", out var o_geo_out)) {
                if (o_geo_out is Dictionary<string, object> d_geo_out) {
                  var geo_out = new to_geo();
                  geo_out.extract_dict(d_geo_out);
                  wt_data_bound.geo_out = new to_bindable_data<to_geo>(geo_out);
                  lbl_wt_typ.Text = d_geo_out.GetValue("wt_typ_string") as string ?? "";
                  }
                }
              if (d_tgt.TryGetValue("l_betrp", out var o_l_betrp_out)) {
                if (o_l_betrp_out is List<object> l_betrp_out) {
                  if (!l_betrp_out.IsNullOrEmpty()) {
                    if (l_betrp_out[0] is Dictionary<string, object> d_betrp_out) {
                      var betrp_out = new to_betrp();
                      betrp_out.extract_dict(d_betrp_out);
                      wt_data_bound.betrp_out = new to_bindable_data<to_betrp>(betrp_out);
                      }
                    }
                  }
                }
              }
            }
          switch (rechnung) {
          case ausl_Auslegung:
            this.grd_geo_out.Visibility = Visibility.Visible;
            this.grd_betrp_out.Visibility = Visibility.Visible;
            break;
          case ausl_Nachrechnung:
            this.grd_geo_out.Visibility = Visibility.Collapsed;
            this.grd_betrp_out.Visibility = Visibility.Visible;
            break;
          case ausl_Reserve:
            this.grd_geo_out.Visibility = Visibility.Collapsed;
            this.grd_betrp_out.Visibility = Visibility.Visible;
            break;
            }
          set_visible_row_in_grid(edt_A_reserve_out, rechnung != ausl_Nachrechnung ? Visibility.Visible : Visibility.Collapsed);
          this.DataContext = null;
          this.DataContext = wt_data_bound;
          }
        }
      catch (Exception ex) {
        edt_out.Text = ex.Message ?? "???";
        }
      }
    #endregion 0001002C01
    #region private void rb_rechnung_Click(object sender, RoutedEventArgs e)
    private void rb_rechnung_Click(object sender, RoutedEventArgs e) {
      var rechnung = get_radio(this, "rechnung");
      switch (rechnung) {
      case ausl_Auslegung:
        break;
      case ausl_Nachrechnung:
        break;
      case ausl_Reserve:
        break;
        }
      var show_fixed = rechnung == ausl_Auslegung;
      // set_fix(chk_lam_staerke_fixed_in, edt_lam_staerke_in, show_fix);
      set_fix(chk_RR_fixed_in, edt_RR_in, show_fixed);
      set_fix(chk_kreise_fixed_in, edt_Kreise_in, show_fixed);
      set_fix(chk_lam_abst_fixed_in, edt_lam_abst_in, show_fixed);
      // set_fix(chk_he_fixed_in, chk_he_in, show_fix);
      set_fix(chk_sam_fixed_in, cmb_sam_dia_in, show_fixed);
      set_visible_row_in_grid(lbl_luft_aus_in,
        rechnung != ausl_Nachrechnung ? Visibility.Visible : Visibility.Collapsed);
      set_visible_row_in_grid(edt_luft_temp_aus_in,
        rechnung != ausl_Nachrechnung ? Visibility.Visible : Visibility.Collapsed);
      set_visible_row_in_grid(edt_med_temp_aus_in,
        rechnung != ausl_Nachrechnung ? Visibility.Visible : Visibility.Collapsed);

      // 
      void set_fix(CheckBox chk, DependencyObject edt, bool show_fix) {
        chk.Visibility = show_fix ? Visibility.Visible : Visibility.Collapsed;
        edt.set_readonly(show_fix && !(chk.IsChecked ?? false));
        }
      }
    #endregion

    // Empty
    #region private void cmb_rohr_DropDownClosed(object sender, EventArgs e)
    private void cmb_rohr_DropDownClosed(object sender, EventArgs e) {
      }
    #endregion
    #region private void cmb_lamelle_SelectionChanged(object sender, SelectionChangedEventArgs e)
    private void cmb_lamelle_SelectionChanged(object sender, SelectionChangedEventArgs e) {
      }
    #endregion
    #region private void cmb_lamelle_DropDownClosed(object sender, EventArgs e)
    private void cmb_lamelle_DropDownClosed(object sender, EventArgs e) {
      }
    #endregion
    #region private void lam_abst_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
    private void lam_abst_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e) {
      }
    #endregion    
    #region private void cmb_ansch_typ_SelectionChanged(object sender, SelectionChangedEventArgs e)
    private void cmb_ansch_typ_SelectionChanged(object sender, SelectionChangedEventArgs e) {
      }
    #endregion
    #region private void cmb_sam_dia_SelectionChanged(object sender, SelectionChangedEventArgs e)
    private void cmb_sam_dia_SelectionChanged(object sender, SelectionChangedEventArgs e) {
      }
    #endregion
    #region private void cmb_einbau_SelectionChanged(object sender, SelectionChangedEventArgs e)
    private void cmb_einbau_SelectionChanged(object sender, SelectionChangedEventArgs e) {
      }
    #endregion
    #region private void luft_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
    private void luft_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e) {
      }
    #endregion
    #region private void med_SelectionChanged(object sender, SelectionChangedEventArgs e)
    private void med_SelectionChanged(object sender, SelectionChangedEventArgs e) {
      }
    #endregion
    #region private void med_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
    private void med_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e) {
      }
    #endregion

    // Tools
    #region public static void set_cmb_key(ComboBox cmb, string key)
    public static void set_cmb_key(ComboBox cmb, string key) {
      ComboBoxItem tgt = null;
      foreach (var item0 in cmb.Items) {
        var item = item0 as ComboBoxItem;
        if (item != null) {
          if (item.Tag is Dictionary<string, object> d) {
            if (d.GetValue("key") as string == key) {
              tgt = item;
              }
            }
          }
        }
      cmb.SelectedItem = tgt;
      }
    #endregion
    #region private static List<Dictionary<string, object>> ld_from_json(sting s)
    private static List<Dictionary<string, object>> ld_from_json(string s) {
      var o = fastJSON.JSON.Parse(s) as List<object>;
      var res = new List<Dictionary<string, object>>();
      foreach (var e in o) {
        res.Add(e as Dictionary<string, object>);
        }
      return res;
      }
    #endregion
    #region private static Dictionary<string, object> d_from_json(string s)
    private static Dictionary<string, object> d_from_json(string s) {
      var res = fastJSON.JSON.Parse(s) as Dictionary<string, object>;
      return res;
      }
    #endregion

    }
  public partial class to_betrp {
    public Dim med_druckv => med_druckv_sammler + med_druckv_kernrohr;
    }
  #region public class to_wt_data_bound
  public class to_wt_data_bound {
    #region public to_bindable_data<to_geo> geo_in
    public to_bindable_data<to_geo> geo_in {
      get; set;
      }
    #endregion
    #region public to_bindable_data<to_betrp> betrp_in
    public to_bindable_data<to_betrp> betrp_in {
      get; set;
      }
    #endregion
    #region public to_bindable_data<to_geo> geo_out
    public to_bindable_data<to_geo> geo_out {
      get; set;
      }
    #endregion
    #region public to_bindable_data<to_betrp> betrp_out
    public to_bindable_data<to_betrp> betrp_out {
      get; set;
      }
    #endregion

    #region public to_wt_data_bound(to_geo geo_in, to_betrp betrp_in)
    public to_wt_data_bound(to_geo geo_in, to_betrp betrp_in) {
      this.geo_in = new to_bindable_data<to_geo>(geo_in);
      this.betrp_in = new to_bindable_data<to_betrp>(betrp_in);
      }
    #endregion
    }
  #endregion
  }
